import { getIntrospectionQuery } from 'graphql';
import { Graffle } from '../entrypoints/alpha/__Graffle.js';
export const introspectionQuery = async (endpoint) => {
    const introspectionQueryDocument = getIntrospectionQuery({
        descriptions: true,
        schemaDescription: true,
        directiveIsRepeatable: true,
        specifiedByUrl: true,
        inputValueDeprecation: true,
    });
    const result = await Graffle.create({ schema: endpoint }).rawStringOrThrow({
        document: introspectionQueryDocument,
    });
    if (!result.data) {
        throw new Error(`No data returned for introspection query.`);
    }
    return result.data;
};
//# sourceMappingURL=_helpers.js.map