import type { OptionsInput } from './generateCode.js';
import { type Input as GenerateInput } from './generateCode.js';
export interface Input {
    outputDirPath: string;
    name?: string;
    code?: Omit<GenerateInput, 'schemaSource' | 'sourceDirPath' | 'options'>;
    defaultSchemaUrl?: URL;
    sourceSchema: {
        type: 'sdl';
        /**
         * Defaults to the source directory if set, otherwise the current working directory.
         */
        dirPath?: string;
    } | {
        type: 'url';
        url: URL;
    };
    /**
     * Defaults to the current working directory.
     */
    sourceDirPath?: string;
    sourceCustomScalarCodecsFilePath?: string;
    schemaPath?: string;
    format?: boolean;
    errorTypeNamePattern?: OptionsInput['errorTypeNamePattern'];
    libraryPaths?: {
        client?: string;
        schema?: string;
        scalars?: string;
    };
}
export declare const generateFiles: (input: Input) => Promise<void>;
//# sourceMappingURL=files.d.ts.map