import { type TypedQueryDocumentNode } from 'graphql';
import type { Anyware } from '../../lib/anyware/__.js';
import type { BaseInput, TypedDocumentString } from '../0_functions/types.js';
import { Schema } from '../1_Schema/__.js';
import type { GlobalRegistry } from '../2_generator/globalRegistry.js';
import { Core } from '../5_core/__.js';
import type { DocumentFn } from './document.js';
import type { GetRootTypeMethods } from './RootTypeMethods.js';
import type { Envelope } from './Settings/Config.js';
import { type Config } from './Settings/Config.js';
import { type Input, type InputToConfig } from './Settings/Input.js';
export type SelectionSetOrIndicator = 0 | 1 | boolean | object;
export type SelectionSetOrArgs = object;
export interface Context {
    retry: undefined | Anyware.Extension2<Core.Core, {
        retrying: true;
    }>;
    extensions: Extension[];
    config: Config;
}
export type TypedContext = Context & {
    schemaIndex: Schema.Index;
};
export type ClientRaw<$Config extends Config> = {
    rawString<$Data, $Variables>(input: BaseInput<TypedDocumentString<$Data, $Variables>>): Promise<Envelope<$Config, $Data>>;
    rawStringOrThrow<$Data, $Variables>(input: BaseInput<TypedDocumentString<$Data, $Variables>>): Promise<Envelope<$Config, $Data, []>>;
    raw<$Data, $Variables>(input: BaseInput<TypedQueryDocumentNode<$Data, $Variables>>): Promise<Envelope<$Config, $Data>>;
    rawOrThrow<$Data, $Variables>(input: BaseInput<TypedQueryDocumentNode<$Data, $Variables>>): Promise<Envelope<$Config, $Data, []>>;
};
export type Extension = {
    name: string;
    anyware?: Anyware.Extension2<Core.Core>;
};
export type Client<$Index extends Schema.Index | null, $Config extends Config> = {
    internal: {
        config: $Config;
    };
} & ClientRaw<$Config> & ($Index extends Schema.Index ? ClientTyped<$Index, $Config> : {}) & {
    use: (extension: Extension | Anyware.Extension2<Core.Core>) => Client<$Index, $Config>;
    retry: (extension: Anyware.Extension2<Core.Core, {
        retrying: true;
    }>) => Client<$Index, $Config>;
};
export type ClientTyped<$Index extends Schema.Index, $Config extends Config> = {
    document: DocumentFn<$Config, $Index>;
} & GetRootTypeMethods<$Config, $Index>;
type Create = <$Input extends Input<GlobalRegistry.SchemaList>>(input: $Input) => Client<$Input['schemaIndex'] extends Schema.Index ? GlobalRegistry.GetSchemaIndexOrDefault<$Input['name']> : null, InputToConfig<$Input>>;
export declare const create: Create;
interface CreateState {
    retry?: Anyware.Extension2<Core.Core, {
        retrying: true;
    }>;
    extensions: Extension[];
}
export declare const createInternal: (input_: Input<any>, state: CreateState) => any;
export {};
//# sourceMappingURL=client.d.ts.map