import type { HasRequiredKeys } from 'type-fest';
import type { Exact } from '../../lib/prelude.js';
import type { Schema } from '../1_Schema/__.js';
import type { GlobalRegistry } from '../2_generator/globalRegistry.js';
import { type Client } from './client.js';
import type { InputRaw, InputToConfig } from './Settings/Input.js';
export type CreatePrefilled = <$Name extends GlobalRegistry.SchemaNames>(name: $Name, schemaIndex: Schema.Index, schemaUrl?: URL) => <$Input extends InputPrefilled<GlobalRegistry.Schemas[$Name]>>(...args: HasRequiredKeys<InputPrefilled<GlobalRegistry.Schemas[$Name]>> extends true ? [input: Exact<$Input, InputPrefilled<GlobalRegistry.Schemas[$Name]>>] : ([input: Exact<$Input, InputPrefilled<GlobalRegistry.Schemas[$Name]>>] | [])) => Client<GlobalRegistry.GetSchemaIndexOrDefault<$Name>, InputToConfig<$Input>>;
/**
 * Create a constructor with some fields prefilled. Fields that can be prefilled are:
 * - `name`
 * - `schemaIndex`
 * - `schema` (URL, if introspection was used for code generation)
 */
export declare const createPrefilled: CreatePrefilled;
export type InputPrefilled<$Schema extends GlobalRegistry.SchemaList> = $Schema extends any ? InputRaw<$Schema> : never;
//# sourceMappingURL=prefilled.d.ts.map